(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue-class-component')) :
    typeof define === 'function' && define.amd ? define(['exports', 'vue-class-component'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.VueClass = {}, global.vueClassComponent));
}(this, (function (exports, vueClassComponent) { 'use strict';

    function State(value) {
        var arr = value ? value.split("/") : undefined;
        return function (target, propertyKey) {
            vueClassComponent.createDecorator(function (options, key) {
                options.computed[key] = function () {
                    var data = this.$store.state;
                    if (!arr) {
                        return data[key];
                    }
                    else {
                        arr.forEach(function (item) {
                            data = data[item];
                        });
                        return data;
                    }
                };
            })(target, propertyKey);
        };
    }

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }

    function Action(value) {
        return function (target, propertyKey) {
            vueClassComponent.createDecorator(function (options, key) {
                options.methods[key] = function () {
                    var _a;
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    var actionName = value || key;
                    return (_a = this.$store).dispatch.apply(_a, __spreadArray([actionName], args));
                };
            })(target, propertyKey);
        };
    }

    function Getter(value) {
        return function (target, propertyKey) {
            vueClassComponent.createDecorator(function (options, key) {
                options.computed[key] = function () {
                    var name = value || key;
                    return this.$store.getters[name];
                };
            })(target, propertyKey);
        };
    }

    function Mutation(value) {
        return function (target, propertyKey) {
            vueClassComponent.createDecorator(function (options, key) {
                options.methods[key] = function () {
                    var _a;
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    var name = value || key;
                    return (_a = this.$store).commit.apply(_a, __spreadArray([name], args));
                };
            })(target, propertyKey);
        };
    }

    Object.defineProperty(exports, 'Options', {
        enumerable: true,
        get: function () {
            return vueClassComponent.Options;
        }
    });
    Object.defineProperty(exports, 'mixins', {
        enumerable: true,
        get: function () {
            return vueClassComponent.mixins;
        }
    });
    exports.Action = Action;
    exports.Getter = Getter;
    exports.Mutation = Mutation;
    exports.State = State;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
